
# MATHEMATICS OF INFRASTRUCTURE PLANNING SS 2012
# Ralf Borndoerfer & Martin Groetschel
# 04/2012
#
# Frequency assignment problem
#
# Rename to 'fap.zpl' and run as 'zimpl [-D FILE=<filename>] fap.zpl'.
#
# Data is read from file <filename> in the following format:
#
# s <1d> <2d> 		 # lower and upper frequency bound 
# g <1d> 			 # globally forbidden frequency
# c <1d> <2d> <3d> 	 # cell id, x-coord, y-coord
# b <1d> <2d> 		 # cell id, locally forbidden frequency
# a <1d,2d,3d,4d,5d> # cell id, cell id, separation, co- and 
#                    # adjacent channnel interference

# parameters (overwritten by command line) ####################################

param FILE := "Tiny.txt";

# input data ##################################################################

# spectrum
param fmin := read FILE as "2n" comment "#abcg";
param fmax := read FILE as "3n" comment "#abcg";

# channels
set F := { fmin .. fmax };
set G := { read FILE as "<2n>" comment "#abcs" };
set T := F - G;

# nodes and locally blocked channels
set V := { read FILE as "<2n>" comment "#abgs" };
set B := { read FILE as "<2n,3n>" comment "#acgs" };

# arcs
set A := { read FILE as "<2n,3n>" comment "#bcgs" };

# separation, co-, and adjacent channel interference
param dist[A] := read FILE as "<2n,3n> 4n" comment "#bcgs";
param cint[A] := read FILE as "<2n,3n> 5n" comment "#bcgs";
param aint[A] := read FILE as "<2n,3n> 6n" comment "#bcgs";

do forall <i,j> in A do check dist[i,j] == 0 or dist[i,j] == 1;
do forall <i,j> in A do check aint[i,j] >= 0 and aint[i,j] <= cint[i,j] and cint[i,j] <= 1.0;

# co- and adjacent channel interferences arcs
set A_cint := { <i,j> in A with cint[i,j] > 0 and dist[i,j] == 0 };
set A_aint := { <i,j> in A with aint[i,j] > 0 };

# IP formulation ###############################################################

# variables

# objective

# constraints



